varying vec3 lightVec;
varying vec3 eyeVec;
uniform sampler2D colorMap;
uniform sampler2D normalMap;

/* Based on the Ozone3d normal map code */
/* TODO: This seems broken specular is not reflecting off the right spots */
void main (void) {
   
   float distSqr = dot(lightVec, lightVec);
   
   vec3 lVec = normalize(lightVec * inversesqrt(distSqr));

   vec3 vVec = normalize(eyeVec);
   
   vec4 base = texture2D(colorMap, gl_TexCoord[0].xy);
   
   vec3 bump = normalize(texture2D(normalMap, gl_TexCoord[0].xy).xyz * 2.0 - 1.0);
   

   
   float diffuse    = max(dot(lVec, bump), 0.0);
   float specular    = pow(clamp(dot(reflect(-lVec, bump), vVec), 0.0, 1.0), 64.0 );
   
   /*
   vec4 vAmbient   = vec4(0.000001,0.000001,0.00001,0);
   vec4 vDiffuse   = vec4(0.75, 0.75, 0.75, 1.0) * diffuse;
   vec4 vSpecular    = vec4(1.0, 1.0, 1.0, 1.0) * specular;
   */
   //gl_FragColor = base*vAmbient + base*vDiffuse ; //+ vec4(1.0, 1.0, 1.0, 0.0)  * clamp(pow(.0001, dot(vVec, bump)), 0.0, 1.0);

   vec4 vAmbient = gl_LightSource[0].ambient * gl_FrontMaterial.ambient;
   vec4 vDiffuse = gl_LightSource[0].diffuse * gl_FrontMaterial.diffuse * diffuse;   
   vec4 vSpecular = gl_LightSource[0].specular * gl_FrontMaterial.specular * specular;   


   gl_FragColor = vAmbient*base +vDiffuse*base +  vec4(1.0, 1.0, 1.0, 0.0) * clamp(1.0-sqrt(sqrt(dot(vVec, bump))), 0.0, 1.0);
   //gl_FragColor = ( vAmbient*base + vDiffuse*base + vSpecular) * att;
 
}