varying vec3 eyeVec;
varying vec3 lightVec;

// Based on the Ozone3d normal map code 
void main(void) {
   gl_Position = ftransform();
   gl_TexCoord[0] = gl_MultiTexCoord0;
   
   vec3 t; 
   vec3 b; 
   
   vec3 c1 = cross(gl_Normal, vec3(0.0, 0.0, 1.0)); 
   vec3 c2 = cross(gl_Normal, vec3(0.0, 1.0, 0.0)); 
   
   if(length(c1)>length(c2))
   {
      t = c1;   
   }
   else
   {
      t = c2;   
   }
   
   t = normalize(t);
   
   b = cross(gl_Normal, t); 
   b = normalize(b);
 
   vec3 n =  gl_NormalMatrix *gl_Normal;
   vec3 vVertex = vec3(gl_ModelViewMatrix * gl_Vertex);
   vec3 tmpVec = gl_LightSource[0].position.xyz - vVertex;

   lightVec.x = dot(tmpVec, t);
   lightVec.y = dot(tmpVec, b);
   lightVec.z = dot(tmpVec, n);
   
   tmpVec = -vVertex;
   eyeVec.x = dot(tmpVec, t);
   eyeVec.y = dot(tmpVec, b);
   eyeVec.z = dot(tmpVec, n);
}
