/* One light for now */
varying vec3 reflectionDirection;

/* Direction from the vertex to the camera */
varying vec3 viewDirection;

/* The value of the normal . light direction */
varying float NdotL;

varying vec3 lightDirection;

void main() {
	vec3 nreflectionDirection = normalize(reflectionDirection);
	vec3 nviewDirection = normalize(viewDirection);

	/* A = ambient light */	
	/* D = diffuse light */
	/* S = specular light */
	/* y = shiney exponent */
	/* ka = Ambient Reflection coefficient  */
	/* kd = diffuse reflection coefficient */
	/* ks = specular reflection coefficient */
	/* (L.N) = light direction dotted with normal */
	/* (R.V) = Direction of reflected light dotted with view vector. */
	/*   shade = ka * A + (D*kd*(L.N) + Sks(R.V)^(y)   */
	
	vec4 ambient = gl_LightSource[0].ambient * 0.45; /* ka here */
	
	vec4 diffuse = gl_LightSource[0].diffuse * .45; /* kd here */
	diffuse = diffuse * NdotL;
	
	/* ks here */
	vec4 spec = gl_LightSource[0].specular*.45; 
	/* y here */
	spec = spec * pow(max(dot(nreflectionDirection, nviewDirection), 0.0), 32.0);

	gl_FragColor = min(ambient+diffuse+spec, 1.0);
}