package com.emarcotte.testrio;

import com.emarcotte.glfoo.math.Quaternion;
import com.emarcotte.glfoo.math.Vector3;

/**
 * Joint.
 * 
 * @author Eugene Marcotte
 */

public class MD5Joint {

	/**
	 * Name of the joint.
	 */

	private String name;

	/**
	 * Parent joint.
	 */

	private MD5Joint parent;

	private Vector3 position;

	private Quaternion orientation;

	public MD5Joint(String name, MD5Joint parent, Vector3 pos, Quaternion o) {
		this.name = name;
		this.parent = parent;
		this.position = pos;
		this.orientation = o;
	}

	public Vector3 getPos() {
		return position;
	}

	public String getName() {
		return name;
	}

	public Quaternion getOrientation() {
		return orientation;
	}

	public boolean hasParent() {
		return parent != null;
	}

	public MD5Joint getParent() {
		return parent;
	}

	public void interpolate(MD5Joint oj, MD5Joint nj, double factor) {
		position.linearInterpolate(oj.getPos(), nj.getPos(), factor);
		//orientation.normalizedLinearInterpolate(oj.getOrientation(), nj
			//	.getOrientation(), factor);
		orientation.slerp(oj.getOrientation(), nj.getOrientation(), factor);
	}
}
